/* Problem URL: https://codeforces.com/contest/2050/problem/F */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int dp(int i, int j, int k, string &a, string &b, string &c)
{
    if (k >= c.size()) {
        return 0;
    }

    if (i >= a.size()) {
        ll tmp = 0;
        while (j < b.size()) {
            if (b[j] != c[k]) {
                tmp++;
            }
            j++;
            k++;
        }
        return tmp;
    }

    if (j >= b.size()) {
        ll tmp = 0;
        while (i < a.size()) {
            if (a[i] != c[k]) {
                tmp++;
            }
            i++;
            k++;
        }
        return tmp;
    }

    if (a[i] != c[k] && b[j] != c[k]) {
        return min(dp(i + 1, j, k + 1, a, b, c), dp(i, j + 1, k + 1, a, b, c)) + 1;
    }

    if (a[i] == b[j]) {
        return min(dp(i + 1, j, k + 1, a, b, c), dp(i, j + 1, k + 1, a, b, c));
    }

    if (a[i] == c[k]) {
        return dp(i + 1, j, k + 1, a, b, c);
    }

    return dp(i, j + 1, k + 1, a, b, c);
}

int inf = INT32_MAX >> 1;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string a, b, c;
        cin >> a >> b >> c;

        // cout << dp(0, 0, 0, a, b, c) << '\n';

        vvi dp(a.size() + 1, vi(b.size() + 1, inf));

        dp[0][0] = 0;

        for (size_t i = 0; i <= a.size(); i++) {
            for (size_t j = 0; j <= b.size(); j++) {
                if (i == 0 && j == 0) {
                    continue;
                }

                if (i > 0) {
                    if (a[i - 1] == c[i + j - 1]) {
                        rmin(dp[i][j], dp[i - 1][j]);
                    } else {
                        rmin(dp[i][j], dp[i - 1][j] + 1);
                    }
                }

                if (j > 0) {
                    if (b[j - 1] == c[i + j - 1]) {
                        rmin(dp[i][j], dp[i][j - 1]);
                    } else {
                        rmin(dp[i][j], dp[i][j - 1] + 1);
                    }
                }
            }
        }

        cout << dp[a.size()][b.size()] << '\n';
    }
}
